<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Rules Tiered Discount by Amasty
 */

namespace Amasty\RulesTieredDiscount\Api\Data;

interface TieredDiscountInterface
{
    public const ID = 'id';
    public const RULE_ID = 'rule_id';
    public const QUANTITY = 'quantity';
    public const DISCOUNT = 'discount';

    /**
     * @return int
     */
    public function getRuleId(): int;

    /**
     * @param int $ruleId
     *
     * @return $this
     */
    public function setRuleId(int $ruleId): TieredDiscountInterface;

    /**
     * @return int
     */
    public function getQuantity(): int;

    /**
     * @param int $quantity
     *
     * @return $this
     */
    public function setQuantity(int $quantity): TieredDiscountInterface;

    /**
     * @return float
     */
    public function getDiscount(): float;

    /**
     * @param float $price
     *
     * @return $this
     */
    public function setDiscount(float $price): TieredDiscountInterface;
}
