<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Rules Tiered Discount by Amasty
 */

namespace Amasty\RulesTieredDiscount\Model;

use Amasty\Rules\Model\Rule as AmastyRule;
use Amasty\Rules\Model\RuleProvider;
use Amasty\Rules\Model\RuleResolver as RulesRuleResolver;
use Amasty\RulesTieredDiscount\Model\ResourceModel\SalesRule\ReadHandler;
use Amasty\RulesTieredDiscount\Model\ResourceModel\TieredDiscount\CollectionFactory;
use Magento\Framework\EntityManager\MetadataPool;
use Magento\SalesRule\Api\Data\RuleExtensionFactory;
use Magento\SalesRule\Model\Rule;

class RuleResolver extends RulesRuleResolver
{
    /**
     * @var ReadHandler
     */
    private $readHandler;

    public function __construct(
        RuleExtensionFactory $extensionFactory,
        MetadataPool $metadata,
        RuleProvider $ruleProvider,
        ReadHandler $readHandler
    ) {
        parent::__construct($extensionFactory, $metadata, $ruleProvider);
        $this->readHandler = $readHandler;
    }

    /**
     * @param Rule $salesRule
     * @return AmastyRule
     */
    public function getSpecialPromotions($salesRule): AmastyRule
    {
        $amrule = parent::getSpecialPromotions($salesRule);
        $this->readHandler->execute($salesRule);

        return $amrule;
    }
}
