<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Rules Tiered Discount by Amasty
 */

namespace Amasty\RulesTieredDiscount\Model;

use Amasty\RulesTieredDiscount\Api\Data\TieredDiscountInterface;
use Amasty\RulesTieredDiscount\Model\ResourceModel\TieredDiscount as TieredDiscountResource;
use Magento\Framework\Model\AbstractModel;

class TieredDiscount extends AbstractModel implements TieredDiscountInterface
{
    protected function _construct()
    {
        $this->_init(TieredDiscountResource::class);
    }

    public function getRuleId(): int
    {
        return (int)$this->getData(self::RULE_ID);
    }

    public function setRuleId(int $ruleId): TieredDiscountInterface
    {
        return $this->setData(self::RULE_ID, $ruleId);
    }

    public function getQuantity(): int
    {
        return (int)$this->getData(self::QUANTITY);
    }

    public function setQuantity(int $quantity): TieredDiscountInterface
    {
        return $this->setData(self::QUANTITY, $quantity);
    }

    public function getDiscount(): float
    {
        return (float)$this->getData(self::DISCOUNT);
    }

    public function setDiscount(?float $price): TieredDiscountInterface
    {
        return $this->setData(self::DISCOUNT, $price);
    }
}
