<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Rules Tiered Discount by Amasty
 */

namespace Amasty\RulesTieredDiscount\Plugin\Rgrid\Model\RuleActions;

use Amasty\Rgrid\Model\RuleActions;
use Amasty\RulesTieredDiscount\Model\Rule\Action\Discount\TieredDiscountPercent;

class AddRuleTypeToGrid
{
    /**
     * @var TieredDiscountPercent
     */
    private $tieredDiscountPercent;

    public function __construct(
        TieredDiscountPercent $tieredDiscountPercent
    ) {
        $this->tieredDiscountPercent = $tieredDiscountPercent;
    }

    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterToOptionArray(RuleActions $subject, array $result): array
    {
        $result[TieredDiscountPercent::ACTION_NAME] = $this->tieredDiscountPercent->getActionLabel();

        return $result;
    }
}
