<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Rules Tiered Discount by Amasty
 */

namespace Amasty\RulesTieredDiscount\Plugin\Rules\Helper\Data;

use Amasty\Rules\Helper\Data;
use Amasty\RulesTieredDiscount\Model\Rule\Action\Discount\TieredDiscountPercent;

class AddTieredDiscountAction
{
    /**
     * @var TieredDiscountPercent
     */
    private $tieredDiscountPercent;

    public function __construct(
        TieredDiscountPercent $tieredDiscountPercent
    ) {
        $this->tieredDiscountPercent = $tieredDiscountPercent;
    }

    public function afterGetDiscountTypes(Data $subject, array $result, bool $asOptions = false): array
    {
        if ($asOptions) {
            return $result;
        }

        foreach ($result as &$actionGroup) {
            if (is_array($actionGroup)
                && isset($actionGroup['label'])
                && ($actionGroup['label']->getText() === 'Multiple Tiered Discount')
            ) {
                $actionGroup['value'][] = [
                    'value' => TieredDiscountPercent::ACTION_NAME,
                    'label' => $this->tieredDiscountPercent->getActionLabel()
                ];
            }
        }

        return $result;
    }
}
