<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Rules Tiered Discount by Amasty
 */

namespace Amasty\RulesTieredDiscount\Plugin\SalesRule\Model\Utility;

use Amasty\RulesTieredDiscount\Model\Rule\Action\Discount\TieredDiscountPercent;
use Magento\Quote\Model\Quote\Item\AbstractItem;
use Magento\SalesRule\Model\Rule;
use Magento\SalesRule\Model\Utility;

class SkipDiscountQtyValidation
{
    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterGetItemQty(Utility $subject, int $result, AbstractItem $item, Rule $rule): int
    {
        // skip magento validation for setting discount_qty
        // because magento use this setting to validate ItemsQty,
        // but we need validate RuleAppliedQty
        if ($rule->getSimpleAction() === TieredDiscountPercent::ACTION_NAME) {
            return (int)$item->getTotalQty();
        }

        return $result;
    }
}
