<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Rules Tiered Discount by Amasty
 */

use Amasty\RulesTieredDiscount\Model\Rule\Action\Discount\TieredDiscountPercent;
use Magento\Framework\Api\SearchCriteriaBuilder;
use Magento\SalesRule\Model\RuleFactory;
use Magento\SalesRule\Model\RuleRepository;
use Magento\TestFramework\Helper\Bootstrap;

$objectManager = Bootstrap::getObjectManager();
$searchCriteriaBuilder = $objectManager->get(SearchCriteriaBuilder::class);
$repository = $objectManager->get(RuleRepository::class);

$searchCriteria = $searchCriteriaBuilder->addFilter('simple_action', TieredDiscountPercent::ACTION_NAME)->create();
$rules = $repository->getList($searchCriteria);
foreach ($rules as $rule) {
    $repository->deleteById($rule->getId());
}
