<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Rules Tiered Discount by Amasty
 */

use Magento\Quote\Model\Quote;
use Magento\Quote\Model\Quote\Address;
use Magento\Quote\Model\QuoteRepository;
use Magento\TestFramework\Helper\Bootstrap;

$objectManager = Bootstrap::getObjectManager();
$quote = $objectManager->create(Quote::class);
$quoteRepository = $objectManager->create(QuoteRepository::class);
$address = $objectManager->create(Address::class);
$address->setData(
    [
        'region' => 'CA',
        'postcode' => '12345',
        'firstname' => 'Firstname',
        'lastname' => 'Lastname',
        'street' => 'Test Street',
        'city' => 'New York',
        'email' => 'www@test.com',
        'telephone' => '1111111111',
        'country_id' => 'US',
        'address_type' => 'shipping'
    ]
);

$quote->setStoreId(1)
    ->setIsActive(true)
    ->setIsMultiShipping(false)
    ->setReservedOrderId('test_amrules_tiered_discount')
    ->setShippingAddress($address);

$quoteRepository->save($quote);
